program PC_KBD;

uses Crt, Dos, Marek;

const Znak: array[0..1] of char = (#250, #251);


var          I: byte;
	OldKbd: procedure;
       Pressed: array[1..83] of boolean;


procedure NewKbd; interrupt;
var Code, Pom: byte;
begin
 Code := port[$60];
 Pom := port[$61];
 port[$61] := Pom or $80;
 port[$61] := Pom;
 port[$20] := $20;
 if Code in [1..83] then Pressed[Code] := TRUE;
 if Code in [129..211] then Pressed[Code - 128] := FALSE;
end;

procedure SetNewKbd;
var I: byte;
begin
  for I := 1 to 83 do Pressed[I] := FALSE;
  GetIntVec(09, @OldKbd);
  SetIntVec(09, Addr(NewKbd));
end;

procedure SetOldKbd;
begin
  SetIntVec(09, Addr(OldKbd));
end;


begin
 ZiadnyCursor;
 Clrscr;
 SetNewKbd;
 repeat
  gotoXY(1,1);
  for I := 1 to 80 do Write( Znak[ Ord(Pressed[I]) ] );
 until Pressed[1];
 SetOldKbd;
end.
