{$A+,B-,D+,E+,F+,I+,L-,N-,O+,R+,S+,V+}
{$M 16384,0,655360}

program Casio;

uses Dos, Crt, Marek, CasUnit;


type
      _PocetPismen = 0..8;
      _NaviacPismen = 0..2;
      _PocetStranok = 1..31;
      _TypZnakov = 1..47;
      _TypCisiel = 0..13;

      _tlc = record
	       Mode, Adjust, Left, Right, Nieco, BoloNieco: Boolean;
	     end;

       _stranka = record
		    NaviacPismen: _NaviacPismen;
		    Znak: array[1..8] of _TypZnakov;
		    Cislo: array[1..12] of _TypCisiel;
		  end;

	  _file = record
		   Pocet, Aktivna: _PocetStranok;
		   Stranka: array[1..30] of _stranka;
		  end;

	   _DB = record
		   Subor: file of _file;
		   FileName: string[12];
		   Otocka: byte;
		   Pocet, Aktivna, OldAktivna: _PocetStranok;
		   Stranka: array[1..31] of _stranka;
		 end;


var
	   I, J, K, L, X, Y, Bt: byte;
	     St: string;
	Pressed: array[1..83] of boolean;
	     DB: _DB;
	 OldKbd: procedure;
	    Tlc: _tlc;



procedure Spomal;
begin
 Delay(40);
end;

procedure Spomaluj;
var I: byte;
begin
 for I := 1 to 10 do if not Tlc.Nieco then Spomal else I := 10;
end;

procedure SetOldKbd;
begin
  SetIntVec(09, Addr(OldKbd));
end;

procedure Koniec;
begin
  SetOldKbd;
  Halt(0);
end;


procedure NewKbd; interrupt;
var Code, Pom: byte;
begin
 Code := port[$60];
 Pom := port[$61];
 port[$61] := Pom or $80;
 port[$61] := Pom;
 port[$20] := $20;
 if Code in [1..83] then Pressed[Code] := TRUE;
 if Code in [129..211] then Pressed[Code - 128] := FALSE;

 if Pressed[1] then Koniec;
 with Tlc do begin
   Mode := Pressed[15];
   Adjust := Pressed[28];
   Left := Pressed[75];
   Right := Pressed[77];
   if (Mode) OR (Adjust) OR (Left) OR (Right) then
     Nieco := TRUE else Nieco := FALSE;
   if Nieco then BoloNieco := TRUE;
 end;
end;

procedure SetNewKbd;
var I: byte;
begin
  for I := 1 to 83 do Pressed[I] := FALSE;
  with Tlc do begin
    Mode := FALSE;
    Adjust := FALSE;
    Right := FALSE;
    Left := FALSE;
    Nieco := FALSE;
    BoloNieco := FALSE;
  end;
  GetIntVec(09, @OldKbd);
  SetIntVec(09, Addr(NewKbd));
end;


procedure DataBanka;

  procedure Novy_DB_subor;
  var Subor: file of _file; Pom: _file;
  begin
    with Pom, Stranka[1] do begin
      Pocet := 1;
      Aktivna := 1;
      NaviacPismen := 0;
      for I := 1 to 8 do Znak[I] := 39;
      for I := 1 to 12 do Cislo[I] := 12;
    end;
    for I := 2 to 30 do Pom.Stranka[I] := Pom.Stranka[1];
    Assign(Subor, DB.FileName);
    Rewrite(Subor);
    Write(Subor, Pom);
    Close(Subor);
  end;

  procedure Nacitaj_DB_Subor;
  var Pom: _file;
  begin
    with DB do begin
      Assign(Subor, FileName);
      Reset(Subor);
      Read(Subor, Pom);
      Close(Subor);
      Pocet := Pom.Pocet;
      Aktivna := Pom.Aktivna;
      for I := 1 to 30 do Stranka[I] := Pom.Stranka[I];
    end;
  end;

  procedure Zapis_DB_Subor;
  var Pom: _file;
  begin
    with DB do begin
      Pom.Pocet := Pocet;
      Pom.Aktivna := Aktivna;
      for I := 1 to 30 do Pom.Stranka[I] := Stranka[I];
      Assign(Subor, FileName);
      Rewrite(Subor);
      Write(Subor, Pom);
      Close(Subor);
    end;
  end;

  procedure VypisStranku;
  begin
    with DB, Stranka[Aktivna] do begin
      Cl;
      for I := 1 to 6 do pZnak(I, Znak[I]);
      for I := 1 to 12 do pCislo(I, Cislo[I]);
    end;
  end;

  procedure Edituj;
  var Editovane: byte; Cis: _TypCisiel; Znk: _TypZnakov;
  label Kon;
    function q(A: byte): byte;
    begin
     if A < 7 then q := A else Q := 6;
    end;
  begin
    Delay(200);
    if DB.Aktivna = 1 then
      begin
	if DB.Pocet = 30 then begin InitZvuk; Zvuk; Halt(0); end;
	Inc(DB.Pocet);
	DB.Aktivna := DB.Pocet;
      end;
    with DB.Stranka[DB.Aktivna] do begin
      repeat
	Editovane := 1;
	Znk := Znak[Editovane];
	repeat     			{ pismena }
	  if Tlc.Left then if Znk > 1 then Dec(Znk) else Znk := 39;
	  if Tlc.Right then if Znk < 39 then Inc(Znk) else Znk := 1;
	  if (Tlc.Left) AND (Tlc.Right) then
	    begin
	      for I := 1 to 8 do Znak[I] := 39;
	      for I := 1 to 12 do Cislo[I] := 12;
	      for I := 1 to 12 do pCislo(I, 12);
	      Sound(4200);
	      Oznam(42, 3, 12, 5, 1, 18);
	      Nosound;
	      Delay(800);
	      VypisStranku;
	      Editovane := 1;
	      Znk := 39;
	    end;
	  Znak[Editovane] := Znk;
	  pZnak(q(Editovane), Znk);
	  if Znak[8] <> 39 then NaviacPismen := 2 else
	    if Znak[7] <> 39 then NaviacPismen := 1 else
	      NaviacPismen := 0;
	  if Tlc.Adjust then Goto Kon;
	  Delay(100);
	  if not Tlc.Nieco then
	    begin
	      pZnak(q(Editovane), 43);
	      for I := 1 to 10 do if not Tlc.Nieco then Spomal;
	    end;
	  pZnak(q(Editovane), Znk);
	  for I := 1 to 10 do if not Tlc.Nieco then Spomal;
	  if Tlc.Adjust then Goto Kon;
	  if Tlc.Mode then
	    begin
	      pZnak(q(Editovane), Znk);
	      Inc(Editovane);
	      if Editovane < 9 then
		begin
		  if Editovane > 6 then for I := 1 to 6 do
		    pZnak(I, Znak[I + Editovane - 6]);
		  Znk := Znak[Editovane];
		  pZnak(q(Editovane), 43);
		  Delay(50);
		end;
	    end;
	until Editovane > 8;
	for I := 1 to 6 do pZnak(I, Znak[I]);

	Editovane := 1;
	Cis := Cislo[Editovane];
	repeat
	  if Tlc.Left then if Cis > 0 then Dec(Cis) else Cis := 12;
	  if Tlc.Right then if Cis < 12 then Inc(Cis) else Cis := 0;
	  Cislo[Editovane] := Cis;
	  pCislo(Editovane, Cis);
	  if Tlc.Adjust then Goto Kon;
	  Delay(100);
	  if not Tlc.Nieco then
	    begin
	     pCislo(Editovane, 13);
	     for I := 1 to 10 do if not Tlc.Nieco then Spomal;
	    end;
	  pCislo(Editovane, Cis);
	  for I := 1 to 10 do if not Tlc.Nieco then Spomal;
	  if Tlc.Adjust then Goto Kon;
	  if Tlc.Mode then
	    begin
	      pCislo(Editovane, Cis);
	      Inc(Editovane);
	      if Editovane < 13 then
		begin
		  Cis := Cislo[Editovane];
		  pCislo(Editovane, 13);
		  Delay(50);
		end;
	    end;
	  if (Tlc.Left) AND (Tlc.Right) then
	    begin
	      for I := 1 to 8 do Znak[I] := 39;
	      for I := 1 to 12 do Cislo[I] := 12;
	      for I := 1 to 12 do pCislo(I, 12);
	      Sound(4200);
	      Oznam(42, 3, 12, 5, 1, 18);
	      Nosound;
	      Delay(800);
	      VypisStranku;
	      Editovane := 13;
	      Cis := 12;
	    end;
	until Editovane > 12;
      until Tlc.Adjust;
    end;
    Kon:
{    if DB.Stranka[DB.Aktivna] = DB.Stranka[1] then
      begin
	Dec(DB.Pocet);
	DB.Aktivna := 1;
      end
     else
       begin
       end; }
    Delay(200);
  end;

  function coo(Poz, Otocka, Naviac: byte): byte;
  var I: byte; xZnak : array[1..16] of _TypZnakov;
  begin
    with DB.Stranka[DB.Aktivna] do begin
      for I := 1 to 8 do xZnak[I] := Znak[I];
      for I := 1 to 8 do xZnak[I + 8] := Znak[I];
      case Otocka of
	0: coo := xZnak[Poz + 0];
	1: coo := xZnak[Poz + 1];
	2: coo := xZnak[Poz + 2];
	3: if Poz in [1..5] then coo := xZnak[Poz + 3] else coo := 47;
	4: if Poz in [1..4, 6..6] then coo := xZnak[Poz + 4] else coo := 47;
	5: if Poz in [1..3, 5..6] then coo := xZnak[Poz + 5] else coo := 47;
	6: if Poz in [1..2, 4..6] then coo := xZnak[Poz + 6] else coo := 47;
	7: if Poz in [1..1, 3..6] then coo := xZnak[Poz + 7] else coo := 47;
	8: if Poz in [2..6] then coo := xZnak[Poz + 8] else coo := 47;
      end;
    end;
  end;

begin
  DB.FileName := 'CASIO-DB.DAT';
  if not Exist(DB.FileName) then Novy_DB_subor;
  Nacitaj_DB_subor;

  with DB, Stranka[Aktivna] do begin
    VypisStranku;
    repeat
      OldAktivna := Aktivna;
      if Tlc.Left then if Aktivna>1 then Dec(Aktivna) else Aktivna := Pocet;
      if Tlc.Right then if Aktivna<Pocet then Inc(Aktivna) else Aktivna := 1;
      if Aktivna <> OldAktivna then VypisStranku;
      if Tlc.Adjust then Edituj;
      if (not Tlc.Nieco) AND (NaviacPismen in [1..2]) then
	begin
	  Otocka := 0;
	  Tlc.BoloNieco := FALSE;
	  Spomaluj;
	  while not Tlc.BoloNieco do
	    begin
	      Spomaluj;
	      if not Tlc.BoloNieco then for I := 1 to 6 do
		pZnak(I, coo(I, Otocka, NaviacPismen));
	      Inc(Otocka);
	      if Otocka = 6 + NaviacPismen + 1 then Otocka := 0;
	    end;
	end;
    until Tlc.Mode;
    Zapis_DB_subor;
  end;
end;


begin
 Cl;
 InitZvuk;
 SetNewKbd;
 DataBanka;
 SetOldKbd;
end.

