{********************************  Unit  MAREK ****************************}

Unit Marek;

INTERFACE
{----------------------------------- Prikazy ------------------------------}

function JeTamMys(MoX, MoY, C: byte): boolean;
procedure ramcek(top,bottom,left,right,popredie,pozadie,
		 f_vnutra: word;co: string);
procedure ciaraY(top,bottom,position,popredie,pozadie: word;co: string);
procedure ciaraX(left,right,position,popredie,pozadie: word;co: string);
procedure tlc_ini(cislo,x,y,f_pozadia,f_tiena,f_textu,f_hotkey,podklad,
		       naviac_riadky: word;
		  text1,hotkey,text2: string);
procedure tlc_prt(cislo: word);
procedure tlc_psh(cislo: word);
procedure ZiadnyCursor;
procedure NormCursor;
procedure WriteC(popredie,pozadie: word; co:string);
procedure WriteXY(x,y:word; co:string);
procedure PoStlacenyPokracuj;
Function LowCase(s: string):string;
Function DoplnNulu(A: Word): String;
Procedure XWrite(A,B,C,D:Byte;S:String);
Procedure Cls;
Procedure ClrKbd;
procedure TXTfarby(A,B: Byte);
procedure Plocha(Popredie,Pozadie,STpop,STpoz: Byte;STsp: String);
procedure InitZvuk;
procedure Zvuk;
procedure Zvuk2;
function Exist(Fajl : String): Boolean;
procedure NapisDoStredu(Y: Byte; Sprava: String);
procedure NapisDoStreduC(Y, Tc, Tb: Byte; Sprava: String);
procedure Abord(Sprava : String);
function LowStr(Str: String): String;
function UpStr(Str: String): String;
procedure Skonci;

var	    v_rozpeti,v_poriadku: boolean;
      QCislo,QX,QY,QF_Pozadia,QF_Tiena,QF_Textu,QF_HotKey,QNaviac_Riadky: array[1..20] of word;
      QText1,QHotKey,QText2: array[1..20] of String;
		  Qzadane: array[1..20] of boolean;
		  Qold_farba,Qdlzka: array[1..20] of byte;

IMPLEMENTATION
uses crt, dos, graph;

{-------------------------- procedure RAMCEK -----------------------------}

function JeTamMys(MoX, MoY, C: byte): boolean;
begin
  if (MoX in [Qx[C]..Qx[C] + Qdlzka[C]]) AND
     (MoY in [(Qy[C] - Qnaviac_Riadky[C])..(Qy[C] + Qnaviac_Riadky[C])])
      then JeTamMys := TRUE else JeTamMys := FALSE;
end;



procedure ramcek(top,bottom,left,right,popredie,pozadie,f_vnutra: word;
		  co: string);

 var oldX,oldY,i,j: byte;
       znak: array[1..6] of string;
	vp,cop: string;
	fa:byte;

 begin
  v_rozpeti:=(top>0) AND (bottom<26) AND (right<81) AND (right>0) AND (left<right) AND (top<bottom);
  v_poriadku:=(co='SINGLE') OR (co='single') OR (co='DOUBLE') OR (co='double') OR (co='NONE') OR (co='none') OR (length(co)=1);
   if not v_poriadku then begin
			   NormVideo;
			   write('Aky ma to byt ten okraj?');
			   halt(1);
			  end;
  if not v_rozpeti then begin
			  textcolor(15);
			  textBackground(0);
			  writeln('Pre ramcek nie su zadane hodnoty spravne!');
			  halt(1);
			 end;
  oldX:=whereX;
  oldY:=whereY;
  fa:=textattr;
  if (co<>'double') AND (co<>'DOUBLE') AND (co<>'single')
      AND (co<>'SINGLE') AND (co<>'none') AND (co<>'NONE') then
   begin
    cop:=co;
    znak[1]:=cop;
    for i:=1 to 78 do znak[1]:=znak[1]+cop;
    Delete(Znak[1],1,(80-right+left));
    for i:=2 to 6 do
     begin
      znak[i]:=cop;
     end;
   end;

   if (co='SINGLE') OR (co='single') then begin
		  znak[2]:='';
		  znak[1]:='';
		  znak[3]:='';
		  znak[4]:='';
		  znak[6]:='';
		  znak[5]:='';
		 Delete(Znak[1],1,(80-right+left));
		 end;
   if (co='DOUBLE') OR (co='double') then begin
		   znak[2]:='';
		   znak[1]:='';
		   znak[3]:='';
		   znak[4]:='';
		   znak[6]:='';
		   znak[5]:='';
		 Delete(Znak[1],1,(80-right+left));
		  end;
   if (co='NONE') OR (co='none') then begin
		   znak[2]:=' ';
		   znak[1]:='                                                                               ';
		   znak[3]:=' ';
		   znak[4]:=' ';
		   znak[6]:=' ';
		   znak[5]:=' ';
		 Delete(Znak[1],1,(80-right+left));
		  end;
   TextColor(popredie);
   TextBackground(pozadie);

    gotoXY(left,top);
    write(znak[3]);
    write(znak[1]);
    write(znak[4]);

    gotoXY(left,bottom);
    write(znak[5]);
    write(znak[1]);
    write(znak[6]);

   for i:=top+1 to bottom-1 do begin
			    gotoXY(left,i);
			    write(znak[2]);
			    gotoXY(right,i);
			    write(znak[2]);
			   end;


   if f_vnutra <> 200 then begin
    TextColor(f_vnutra);
    vp:='';
    delete(vp,1,(80-right+left));
      for i:=top+1 to bottom-1 do begin
				    gotoXY(left+1,i);
				    write(vp);
				   end;
   end;
  gotoXY(oldX,oldY);
  textattr:=fa;
end;

{---------------------------------------------------------------------------}

{-------------------------- CIARA  Y  --------------------------------------}
procedure ciaraY(top,bottom,position,popredie,pozadie: word;co: string);
 var oldX,oldY,i,qq: byte;
 begin
  oldX:=whereX;
  oldY:=whereY;
  qq:=TextAttr;
   v_poriadku:=(co='SINGLE') OR (co='single') OR (co='DOUBLE') OR (co='double') OR
     (co='NONE') OR (co='none') OR (length(co)=1);
   v_rozpeti:=(top>0) AND (bottom<26) AND (top<bottom) AND (position>0) AND (position<81);
   if not v_poriadku then begin
			   NormVideo;
			   write('Aka ma to byt ta ciara?');
			   halt(1);
			  end;
   if not v_rozpeti  then begin
			   NormVideo;
			   write('Zle hodnoty pre poziciu, alebo velkost ciary!');
			   halt(1);
			  end;
   if (co='SINGLE') OR (co='single') then co:='';
   if (co='DOUBLE') OR (co='double') then co:='';
   if (co='NONE')  OR  (co='none')   then co:=' ';

  textcolor(popredie);
  textbackground(pozadie);
  for i:=top to bottom do begin
			    gotoXY(position,i);
			    write(co);
			  end;
  gotoXY(oldX,oldY);
  TextAttr:=qq;
 end;
{---------------------------------------------------------------------------}
{-------------------------- CIARA  X  --------------------------------------}
procedure ciaraX(left,right,position,popredie,pozadie: word;co: string);
 var oldX,oldY,i,qq: byte;
 begin
  oldX:=whereX;
  oldY:=whereY;
  qq:=TextAttr;
   v_poriadku:=(co='SINGLE') OR (co='single') OR (co='DOUBLE') OR (co='double') OR
     (co='NONE') OR (co='none') OR (length(co)=1);
   v_rozpeti:=(left>0) AND (right<81) AND (position>0) AND (position<26);
   if not v_poriadku then begin
			   NormVideo;
			   write('Aka ma to byt ta ciara?');
			   halt(1);
			  end;
   if not v_rozpeti  then begin
			   NormVideo;
			   write('Zle hodnoty pre poziciu, alebo velkost ciary!');
			   halt(1);
			  end;
   if (co='SINGLE') OR (co='single') then co:='';
   if (co='DOUBLE') OR (co='double') then co:='';
   if (co='NONE')  OR  (co='none')   then co:=' ';
  textcolor(popredie);
  textbackground(pozadie);
  for i:=left to right do begin
			    gotoXY(i,position);
			    write(co);
			  end;
  gotoXY(oldX,oldY);
  TextAttr:=qq;
 end;

{---------------------------------------------------------------------------}
{-----------------------  TLC_INI  -----------------------------------------}

procedure tlc_ini(cislo,x,y,f_pozadia,f_tiena,f_textu,f_hotkey,podklad,
		       naviac_riadky: word;
		  text1,hotkey,text2: string);
 var     r: registers;
     zleje: boolean;
     dlzka,oldX,oldY: byte;
      pom: byte;
begin
 dlzka:=(length(text1)+length(hotkey)+length(text2));
 zleje:=FALSE;
  if (cislo<0) OR (cislo>20) then zleje:=TRUE;
  if (x<1) OR (x>=(80-dlzka)) then zleje:=TRUE;
  if (y<(1+naviac_riadky)) OR (y>(26+naviac_riadky)) then zleje:=TRUE;

   if zleje then begin
		   NormVideo;
		   writeln('Zle zadane hodnoty pre umiestnenie (cislo) tlacitka!');
		   Halt(1);
		 end;
  oldX:=whereX;
  oldY:=whereY;

  Qzadane[cislo]:=TRUE;
  Qx[cislo]:=x;
  Qy[cislo]:=y;
  Qf_pozadia[cislo]:=f_pozadia;
  Qf_tiena[cislo]:=f_tiena;
  Qf_textu[cislo]:=f_textu;
  Qf_hotkey[cislo]:=f_hotkey;
  Qnaviac_riadky[cislo]:=naviac_riadky;
  Qtext1[cislo]:=text1;
  Qhotkey[cislo]:=hotkey;
  Qtext2[cislo]:=text2;
  Qdlzka[cislo]:=dlzka;
  Qold_farba[cislo]:=podklad;

  GotoXY(oldX,oldY);
end;

{---------------------------------------------------------------------------}
{-----------------------  TLC_PRT  -----------------------------------------}

procedure tlc_prt(cislo: word);

 var oldX,oldY,i,gg: byte;
	  spaces: string;
 begin
   if not Qzadane[cislo] then begin
			       NormVideo;
			       writeln('TLC_PRT: Zle cislo tlacitka');
			       halt(0);
			      end;
  oldX:=whereX;
  oldY:=whereY;
  gg:=textattr;
  spaces:=' ';

   GotoXY(Qx[cislo],Qy[cislo]);
    TextBackground(Qf_pozadia[cislo]);
    TextColor(Qf_textu[cislo]);
     Write(Qtext1[cislo]);
    TextColor(Qf_hotkey[cislo]);
     Write(Qhotkey[cislo]);
    TextColor(Qf_textu[cislo]);
     Write(Qtext2[cislo]);

	 Textbackground(Qold_farba[cislo]);
	 TextColor(Qf_tiena[cislo]);
	  For i:=(Qx[cislo]+1) to (Qx[cislo]+Qdlzka[cislo]) do
	      Begin
	       GotoXY((i),(Qy[cislo]+Qnaviac_riadky[cislo]+1));
		Write('');
	       end;

      if Qnaviac_riadky[cislo] > 0 then
	   begin
	    for i:=(length(spaces)+1) to (Qdlzka[cislo]) do
	     begin
	      spaces:=spaces+' ';
	     end;
	    for i:=1 to Qnaviac_riadky[cislo] do
	     begin
	      GotoXY((Qx[cislo]),(Qy[cislo]+i));
	      TextBackground(Qf_pozadia[cislo]);
	       TextColor(Qf_textu[cislo]);
		Write(spaces);
	       TextColor(Qf_tiena[cislo]);
		Write('');
	      GotoXY((Qx[cislo]),(Qy[cislo]-i));
	       TextBackground(Qf_pozadia[cislo]);
	       TextColor(Qf_textu[cislo]);
		Write(spaces);
	       TextColor(Qf_tiena[cislo]);
		Write('');
	     end;
	   GotoXY((Qx[cislo]+Qdlzka[cislo]),(Qy[cislo]));
	   Write('');
	  end;
      GotoXY((Qx[cislo]+Qdlzka[cislo]),(Qy[cislo]-Qnaviac_riadky[cislo]));
     Textbackground(Qold_farba[cislo]);
    TextColor(Qf_tiena[cislo]);
   Write('');
  GotoXY(OldX,OldY);
 textattr:=gg;
end;

{---------------------------------------------------------------------------}
{-----------------------  TLC_PSH  -----------------------------------------}

procedure tlc_psh(cislo: word);

 var oldX,oldY,i,gg: byte;
	  spaces: string;
 begin
   if not Qzadane[cislo] then begin
			       NormVideo;
			       writeln('TLC_PSH: Zle cislo tlacitka');
			       halt(0);
			      end;
  oldX:=whereX;
  oldY:=whereY;
  gg:=textattr;
  spaces:=' ';
   Textbackground(Qold_farba[cislo]);
   GotoXY(Qx[cislo],Qy[cislo]);
   write(' ');
   GotoXY(Qx[cislo]+1,Qy[cislo]);
    TextBackground(Qf_pozadia[cislo]);
    TextColor(Qf_textu[cislo]);
     Write(Qtext1[cislo]);
    TextColor(Qf_hotkey[cislo]);
     Write(Qhotkey[cislo]);
    TextColor(Qf_textu[cislo]);
     Write(Qtext2[cislo]);


      if Qnaviac_riadky[cislo] > 0 then
	   begin
	    for i:=(length(spaces)+1) to (Qdlzka[cislo]) do
	     begin
	      spaces:=spaces+' ';
	     end;
	    for i:=1 to Qnaviac_riadky[cislo] do
	     begin

	   Textbackground(Qold_farba[cislo]);
	   GotoXY(Qx[cislo],Qy[cislo]-i);
	   write(' ');
	   GotoXY(Qx[cislo],Qy[cislo]+i);
	   write(' ');

	      GotoXY((Qx[cislo]+1),(Qy[cislo]+i));
	      TextBackground(Qf_pozadia[cislo]);
	       TextColor(Qf_textu[cislo]);
		Write(spaces);
	      GotoXY((Qx[cislo]+1),(Qy[cislo]-i));
	       TextBackground(Qf_pozadia[cislo]);
	       TextColor(Qf_textu[cislo]);
		Write(spaces);
	     end;
	  end;
	 Textbackground(Qold_farba[cislo]);
	  For i:=(Qx[cislo]+1) to (Qx[cislo]+Qdlzka[cislo]) do
	      Begin
	       GotoXY((i),(Qy[cislo]+Qnaviac_riadky[cislo]+1));
		Write(' ');
	       end;
  GotoXY(OldX,OldY);
 textattr:=gg;
end;

{---------------------------------------------------------------------------}
{----------------------- ZiadnyCursor --------------------------------------}

procedure ZiadnyCursor;

var
  Reg : Registers;

begin
  with Reg do
  begin
    AH := 1;
    BH := 0;
    CX := $2000;
     Intr($10, Reg);
   end;
end;

{---------------------------------------------------------------------------}
{------------------------- NormCursor --------------------------------------}
procedure NormCursor;

var
  Reg : Registers;

begin
  with Reg do
  begin
    AH := 1;
    BH := 0;
    CX := $0607;
     Intr($10, Reg);
   end;
end;

{---------------------------------------------------------------------------}
{------------------------- WriteC ------------------------------------------}

procedure WriteC(popredie,pozadie:word; co:string);

var oldX,oldY,oldF: byte;

 begin
  oldX:=whereX;
  oldY:=whereY;
  oldf:=textattr;
  textcolor(popredie);
  textbackground(pozadie);
  write(co);
  textattr:=oldF;
end;
{-------------------------- procedure WRITEXY ----------------------------}

procedure WriteXY(x,y:word; co:string);
var oldX,oldY: byte;
begin
 oldX:=whereX;
 oldY:=whereY;
  gotoXY(x,y);
  write(co);
 GotoXY(oldX,oldY);
end;
{----------------- procedure PoStlacenyPokracuj -----------------------}
procedure PoStlacenyPokracuj;
var ch: char;
begin
 repeat until KeyPressed;
 ch:=readkey;
end;

{-------------------------- Function LowCase ----------------------------}
Function LowCase(s: string):string;
Var I:Byte;
Begin
 For I:=1 to Length(S) do
  Begin
   If S[I] in ['A'..'Z'] then S[I]:=Chr(Ord(S[I])+32);
  End;
 LowCase:=S;
End;

{-------------------------- Function DoplnNulu ----------------------------}
Function DoplnNulu(A: Word): String;
Var S: String;
Begin
 S:='';
 Str(A,S);
 If A<10 Then S:='0'+S;
 DoplnNulu:=S;
End;

{-------------------------- Procedure XWrite ----------------------------}
Procedure XWrite(A,B,C,D:Byte;S:String);
Begin
 GotoXY(A,B);
 TextColor(C);
 TextBackground(D);
 Write(S);
End;

{-------------------------- Procedure Cls ----------------------------}
Procedure Cls;
Var F: Byte;
Begin
 Window(1,1,80,25);
 TextColor(7);
 TextBackground(0);
 ClrScr;
End;

{-------------------------- Procedure ClrKbd ----------------------------}
Procedure ClrKbd;
Var Ch: Char;
Begin
 While KeyPressed do Ch:=Readkey;
End;

{-------------------------- proc. TXTfarby ----------------------------}

procedure TXTfarby(A,B: Byte);
begin
 TextColor(A);
 TextBackground(B);
end;

{-------------------------- proc. Plocha ----------------------------}

procedure Plocha(Popredie,Pozadie,STpop,STpoz: Byte;STsp: String);
var I: Byte; S: String;
begin
 TXTfarby(Popredie,Pozadie);
 S:='';
 GotoXY(1,1);
 for I:=1 to 24 do Write(S);
 if STsp = '' then
  begin
   GotoXY(1,24);
   InsLine;
   GotoXY(1,24);
   Write(S);
  end
 else
  begin
   TXTfarby(STpop,STpoz);
   ClrEol;
   WriteXY(1,25,STsp);
  end;
end;

{-------------------------- Proc InitZvuk ----------------------------}
procedure InitZvuk;
begin
 Sound(30);
 Nosound;
end;


{-------------------------- Proc Zvuk ----------------------------}
procedure Zvuk;
begin
 Sound(1300);
 Delay(30);
 Nosound;
end;

{-------------------------- Proc Zvuk2 ----------------------------}
procedure Zvuk2;
begin
 Sound(800);
 Delay(30);
 Nosound;
end;

function Exist(Fajl : String): Boolean;
var S: PathStr;
begin
 S := FSearch(Fajl, '');
 if S = '' then Exist := FALSE else EXIST := TRUE;
end;

procedure NapisDoStredu(Y: Byte; Sprava: String);
begin
 WriteXY(40 - (Length(Sprava) div 2), Y, Sprava);
end;

procedure NapisDoStreduC(Y, Tc, Tb: Byte; Sprava: String);
begin
 XWrite(40 - (Length(Sprava) div 2), Y, Tc, Tb, Sprava);
end;

procedure Abord(Sprava : String);
begin
 TXTfarby(7, 0);
 Writeln;
 GotoXY(1, WhereY);
 Writeln('FATAL: ' + Sprava);
 Zvuk;
 Halt(255);
end;

function LowStr(Str: String): String;
var I: Byte; S: String;
begin
 S := '';
 for I := 1 to Length(Str) do if Ord(Str[I]) in [65..90] then
	  S := S + Chr( Ord(Str[I]) + 32 ) else S := S + Str[I];
 LowStr := S;
end;

function UpStr(Str: String): String;
var I: Byte; S: String;
begin
 S := '';
 for I := 1 to Length(Str) do if Ord(Str[I]) in [97..122] then
	  S := S + Chr( Ord(Str[I]) - 32 ) else S := S + Str[I];
 UpStr := S;
end;

procedure Skonci;
begin
 CloseGraph;
 Halt(1);
end;

end.



